bounce = {}
bounce.image = {}
bounce.maxBounce = 10
bounce.precision = 4
bounce.weapons = {49,51,52,53,54,72,76,89}
bounce.activated = {}

misc.addServerTransfer("gfx/bounce_line.png")
misc.addServerTransfer("gfx/line_bounce.png")

addhook("join","bounce.join")
function bounce.join(id)
	bounce.image[id] = {}
	bounce.image[id].bouce = {}
end

addhook("leave","bounce.leave")
function bounce.leave(id)
	bounce.undraw(id)
end

addhook("die","bounce.die")
function bounce.die(victim,killer,weapon,x,y)
	bounce.undraw(victim)
end

addhook("attack","bounce.attack")
function bounce.attack(id)
	timer(1,"bounce.checkWep",id)
end

function bounce.undraw(id)
	if not(bounce.activated[id] == nil) then
		bounce.activated[id] = nil
		i = #bounce.image[id].bouce
		while (i > 0) do
			freeimage(bounce.image[id].bouce[i].line)
			freeimage(bounce.image[id].bouce[i].dot)
			bounce.image[id].bouce[i] = nil
			i = i - 1
		end
	end
end


addhook("collect","bounce.collect")
function bounce.collect(id,iid,type,ain,a,mode)
	timer(1,"bounce.checkWep",id)
end

addhook("drop","bounce.drop")
function bounce.drop(id,iid,typ,ain,a,mode,x,y)
	timer(1,"bounce.checkWep",id)
end

addhook("select","bounce.select")
function bounce.select(id,typ,mode)
	timer(1,"bounce.checkWep",id)
end

function bounce.checkWep(id)
	id = tonumber(id)
	wep = player(id,"weapontype")
	i = 0
	while (i < #bounce.weapons) do
		i = i + 1
		if wep == bounce.weapons[i] then
			bounce.activated[id] = true
			return 0
		end
	end
	bounce.undraw(id)
end

addhook("ms100","bounce.ms100")
function bounce.ms100()
	for v,k in pairs(bounce.activated) do
		if not(player(v,"bot")) then
			reqcld(v,2,bounce.calc)
		end
	end
end

function bounce.calc(id,x,y)
	px = player(id,"x")
	py = player(id,"y")
	dir = misc.point_direction(px,py,x,y)
	dist = misc.point_distance(px,py,x,y)
	xc = px
	yc = py
	xmove = misc.lengthdir_x(dir,bounce.precision)
	ymove = misc.lengthdir_y(dir,bounce.precision)
	last_bouncex = px
	last_bouncey = py
	bounces = 0
	i = 0
	while ((i < dist) and (bounces < bounce.maxBounce)) do
		i = i + bounce.precision
		xc = xc + xmove
		yc = yc + ymove
		tilex = misc.pixel_to_tile(xc)
		tiley = misc.pixel_to_tile(yc)
		if tile(tilex,tiley,"wall") then
			oldtilex = misc.pixel_to_tile(xc)
			oldtiley = misc.pixel_to_tile(yc)
			while (tile(oldtilex,oldtiley,"wall")) do
				i = i - 1
				xc = xc - misc.lengthdir_x(dir,.25)
				yc = yc - misc.lengthdir_y(dir,.25)
				oldtilex = misc.pixel_to_tile(xc)
				oldtiley = misc.pixel_to_tile(yc)
			end
			bounce_dir = math.atan2(tilex - oldtilex,oldtiley - tiley) * 180 / math.pi
			dir = (bounce_dir - 180) - (dir - bounce_dir)
			xmove = misc.lengthdir_x(dir,bounce.precision)
			ymove = misc.lengthdir_y(dir,bounce.precision)
			bounces = bounces + 1
			if (bounce.image[id].bouce[bounces] == nil) then
				bounce.image[id].bouce[bounces] = {}
				bounce.image[id].bouce[bounces].line = bounce.createLine(last_bouncex,last_bouncey,xc,yc,id)
				bounce.image[id].bouce[bounces].dot = image("gfx/line_bounce.png",xc,yc,3,id)
			else
				bounce.moveLine(bounce.image[id].bouce[bounces].line,last_bouncex,last_bouncey,xc,yc)
				tween_move(bounce.image[id].bouce[bounces].dot,100,xc,yc)
				tween_scale(bounce.image[id].bouce[bounces].dot,100,1,1)
			end
			last_bouncex = xc
			last_bouncey = yc
		end
	end
	xc = xc - xmove
	yc = yc - ymove
	bounces = bounces + 1
	if (bounce.image[id].bouce[bounces] == nil) then
		bounce.image[id].bouce[bounces] = {}
		bounce.image[id].bouce[bounces].line = bounce.createLine(last_bouncex,last_bouncey,xc,yc,id)
		bounce.image[id].bouce[bounces].dot = image("gfx/line_bounce.png",xc,yc,3,id)
	else
		bounce.moveLine(bounce.image[id].bouce[bounces].line,last_bouncex,last_bouncey,xc,yc)
		tween_move(bounce.image[id].bouce[bounces].dot,100,xc,yc)
		tween_scale(bounce.image[id].bouce[bounces].dot,100,2,2)
	end
	last_bouncex = xc
	last_bouncey = yc
	-- free images
	i = #bounce.image[id].bouce
	while (i > bounces) do
		freeimage(bounce.image[id].bouce[i].line)
		freeimage(bounce.image[id].bouce[i].dot)
		bounce.image[id].bouce[i] = nil
		i = i - 1
	end
end

function bounce.moveLine(img,x,y,x2,y2)
	local dist = misc.point_distance(x,y,x2,y2)
	local dir = misc.point_direction(x,y,x2,y2)
	tween_move(img,100,x+misc.lengthdir_x(dir,dist*.5),y+misc.lengthdir_y(dir,dist*.5),dir)
	tween_scale(img,100,2,dist)
end

function bounce.createLine(x,y,x2,y2,id)
	local dist = misc.point_distance(x,y,x2,y2)
	local dir = misc.point_direction(x,y,x2,y2)
	local img = image("gfx/bounce_line.png",0,0,3,id)
	imagepos(img,x+misc.lengthdir_x(dir,dist*.5),y+misc.lengthdir_y(dir,dist*.5),dir)
	imagescale(img,1,dist)
	return img
end