misc = {}

function misc.pixel_to_tile(pixel)
	return misc.round((pixel-16)/32)
end

function misc.tile_to_pixel(tile)
	return (tile*32)+16
end

function misc.point_direction(x1,y1,x2,y2)
	return -math.deg(math.atan2(x1-x2,y1-y2))
end

function misc.point_distance(x1,y1,x2,y2)
	return math.sqrt((x1-x2)^2 + (y1-y2)^2)
end

function misc.lengthdir_x(dir,length)
	return math.cos(math.rad(dir - 90))*length
end

function misc.lengthdir_y(dir,length)
	return math.sin(math.rad(dir - 90))*length
end

function misc.split_text(text)
	local command_input = {}
	for word in string.gmatch(text, "[!-z]+") do
		command_input[#command_input+1] = word
	end
	return command_input
end

function misc.fileExists(file)
	local file_check = io.open(file,"r")
	if file_check == nil then
		return false
	end
	file_check:close()
	return true
end

function misc.isNearPlayers(x,y,dist)
	local pl = player(0,"tableliving")
	for i=1,#pl do
		if player(pl[i],"x") < x+dist and player(pl[i],"x") > x-dist and player(pl[i],"y") < y+dist and player(pl[i],"y") > y-dist then
			return pl[i]
		end
	end
	return 0
end

function misc.round(num,base)
	if base == nil then
		return math.floor(num+0.5)
	else
		base = math.pow(10,base)
		return math.floor((num*base)+0.5)/base
	end
end

function misc.debugImage(x,y,r,g,b,t)
	local temp = image("gfx/hud_dot.bmp",x,y,1)
	if t == nil then
		t = 1000
	end
	timer(t,"freeimage",temp)
	if (r == nil) == false then
		imagecolor(temp,r,g,b)
	end
end

function misc.hudText(id,pid,text,x,y,align)
	parse("hudtxt2 "..pid.." "..id.." \""..text.."\" "..x.." "..y.." "..align.."")
	return id
end

function misc.hudTextFade(id,pid,duration,alpha)
	parse("hudtxtalphafade "..pid.." "..id.." "..duration.." "..alpha.."")
	return id
end

function misc.hudTextColor(id,pid,duration,r,g,b)
	parse("hudtxtcolorfade "..pid.." "..id.." "..duration.." "..r.." "..g.." "..b.."")
	return id
end

function misc.explosion(x,y,size,dmg,src)
	parse("explosion "..x.." "..y.." "..size.." "..dmg.." "..src)
end

misc.armourValue = {{id=206,protection=0}, -- stealth armour
{id=205,protection=95}, -- super armour
{id=204,protection=0}, -- medic armour
{id=203,protection=75}, -- heavy armour
{id=202,protection=50}, -- medium armour
{id=201,protection=25}} -- light armour
function misc.calcDamage(id,dmg)
	local armor = player(id,"armor")
	for i=1,#misc.armourValue do
		if armor == misc.armourValue[i].id then
			return dmg - ((dmg / 100) * misc.armourValue[i].protection)
		end
	end
	return dmg
end

function misc.colorTextPercent(percent)
	if percent > 100 then
		percent = 100
	end
	local r = misc.round(255-(percent*2.55))
	local g = misc.round(percent*2.55)
	local b = 0
	return (""..misc.minimum_3(r)..misc.minimum_3(g)..misc.minimum_3(b))
end

function misc.rgb(r,g,b)
	return (""..misc.minimum_3(r)..misc.minimum_3(g)..misc.minimum_3(b))
end

function misc.minimum_3(text)-- you arent really intended to use this function
	text = tostring(text)
	while (string.len(text) < 3) do
		text = "0"..text
	end
	return text
end

function misc.eval(code)
	file = io.open("sys/lua/eval.lua","w")
	if type(code) == "string" then
		file:write(code)
	end
	if type(code) == "table" then
		i = 0
		while (i < #code) do
			i = i + 1
			file:write(code[i])
		end
	end
	file:close()
	ret = dofile("sys/lua/eval.lua")
	os.remove("sys/lua/eval.lua")
	return ret
end

-- sense CS2D reads servertransfer BEFORE lua, you need to restart, after your lua used this function

--if you want this function, then BE IN MIND that the current content in servertransfer.lst will be erased!
-- START UNCOMMENTING EVERYTHING UNDER THIS LINE, IF YOU WANNA USE THIS FUNCTION
-- file = io.open("sys/servertransfer.lst","w")
-- file:write("")
-- file:close()
-- function misc.addServerTransfer(image)
	-- file = io.open("sys/servertransfer.lst","a")
	-- file:write(image.."\n")
	-- file:close()
-- end